{% extends "materiel.html" %}
{% load static icon %}

{% block title %}Gestion du matériel{% endblock %}

{% block navbar_materiel_bureau %}
    active
{% endblock %}

{% block content %}

    <!-- Modal -->
    <div class="modal fade" id="modal" tabindex="-1" role="dialog" aria-labelledby="modalLabel" aria-hidden="true">
        <div class="modal-dialog" role="document">
            <div class="modal-content">
                <p>
                    Chargement ...
                </p>
            </div>
        </div>
    </div>

    <header>
        <h1>Gestion du matériel</h1>

        {% if alerts %}
            <div class="header-content">
                {% for alert in alerts %}
                    <div class="alert alert-{{ alert.type }}" role="alert">
                        <strong>{{ alert.titre }}</strong>{{ alert.contenu }}
                    </div>
                {% endfor %}
            </div>
        {% endif %}
    </header>


    <div class="container-fluid">
        <div class="collapsible-section-title" onclick="toggleForm()">
            <h2 class="title">Ajouter un élément</h2>
            <h2 class="title">
                <a id="collapseLinkForm" class="title collapse-link toggle-off" data-toggle="collapse" href="#addForm">&gt</a>
            </h2>
        </div>

        <section>
            <form id="addForm" class="needs-validation collapse" enctype="multipart/form-data" method="post" action="{% url 'materiel' %}">
                {% csrf_token %}

                <!-- Nom -->
                <div class="form-group">
                    {{ form.nom.label_tag }}
                    {{ form.nom }}
                    <div class="invalid-feedback">
                        Vous devez spécifier un nom valide !
                    </div>
                </div>

                <!-- Type -->
                <div class="form-group">
                    {{ form.typeMateriel.label_tag }}
                    <a data-toggle="modal" id="btn-ajoutType" data-target="#modal"
                       class="btn btn-outline-dark btn-sm"><i class="fas fa-plus-circle"></i> Ajouter un type</a>
                    {{ form.typeMateriel }}
                    <div class="invalid-feedback">
                        Vous devez spécifier un type de matériel !
                    </div>
                </div>


                <!-- Propriétaire -->
                <div class="form-group">
                    {{ form.proprietaireMatos.label_tag }}
                    {{ form.proprietaireMatos }}
                </div>

                <!-- AnnéeAchat -->
                <div class="form-group">
                    {{ form.anneeAchat.label_tag }}
                    <div class="input-group" id="{{ form.anneeAchat.id_for_label }}" data-target-input="nearest">
                        <div class="input-group-prepend" data-target="#{{ form.anneeAchat.id_for_label }}"
                             data-toggle="datetimepicker">
                            <span class="input-group-text"><i class="far fa-calendar"></i></span>
                        </div>
                        {{ form.anneeAchat }}
                        <div class="invalid-feedback">
                            Vous devez spécifier une date d'achat ! (ex: 26/12/2018)
                        </div>
                    </div>
                </div>

                <!-- Caution -->
                <div class="form-group">
                    {{ form.montantCaution.label_tag }}
                    <div class="input-group">
                        {{ form.montantCaution }}
                        <div class="input-group-append">
                            <span class="input-group-text">€</span>
                        </div>
                    </div>
                    <div class="invalid-feedback">
                        Vous devez spécifier un montant de caution ! (ex: 300€)
                    </div>
                </div>

                <div class="form-group">
                    {{ form.prixLocation.label_tag }}
                    <div class="input-group">
                        {{ form.prixLocation }}
                        <div class="input-group-append">
                            <span class="input-group-text">€</span>
                        </div>
                    </div>
                </div>

                <p>
                    {{ form.photo.label_tag }}
                    {{ form.photo }}
                </p>


                <!-- Quantité -->
                <div class="form-group">
                    {{ form.quantite.label_tag }}
                    {{ form.quantite }}
                    <div class="invalid-feedback">
                        Vous devez spécifier une quantité !
                    </div>
                </div>

                <!-- Description -->
                <div class="form-group">
                    {{ form.description.label_tag }}
                    {{ form.description }}
                    <div class="invalid-feedback">
                        Vous devez ajouter une description !
                    </div>
                </div>

                <!-- Bouton -->
                <div class="row">
                    <div class="offset-md-5 col-md-2">
                        <button type="submit" id="valider" class="btn btn-primary btn-xs">Ajouter l'élément</button>
                    </div>
                </div>
            </form>
        </section>

        <h2 class="title">Modifier la liste du matériel</h2>
        {% regroup materiels by typeMateriel as materiels_categorises %}
        {% for type in materiels_categorises %}
            {% if type.grouper %}
                <h3>{{ type.grouper.typeMateriel }}</h3>
            {% else %}
                <h3>Autres</h3>
            {% endif %}

            {% for matos in type.list %}
                <div class="card card-lg">
                    <div class="card-body">
                        <div class="row" id="row-{{ matos.id }}">
                            <div class="col-md-1">
                                <img class="photo-matos" src="{% url 'photo_materiel' matos.id %}" name="{{ matos.id }}"
                                     alt="Photo du {{ matos.nom }}"/>
                            </div>
                            <div class="col-md-8">
                                <h3><a data-toggle="collapse" class="dropdown-toggle" aria-expanded="false"
                                       href="#caracteristiques-{{ matos.id }}">{{ matos.nom }}</a></h3>
                                <p>{{ matos.description }}</p>
                                <div class="row">
                                    <ul class="list-group collapse" id="caracteristiques-{{ matos.id }}">
                                        <li class="list-group-item">Type : {{ matos.typeMateriel }}</li>
                                        <li class="list-group-item">Quantité : {{ matos.quantite }}</li>
                                        <li class="list-group-item">Propriétaire : {{ matos.proprietaireMatos }}</li>
                                        <li class="list-group-item">Date d'achat : {{ matos.anneeAchat }}</li>
                                        <li class="list-group-item">Caution : {{ matos.montantCaution }}€</li>
                                        <li class="list-group-item">Prix de location : {{ matos.prixLocation }}€</li>
                                    </ul>
                                </div>
                            </div>
                            <div class="col-md-1">
                                <button type="button" id="modifier-{{ matos.id }}" name="{{ matos.id }}"
                                        class="btn btn-outline-dark" data-toggle="modal" data-target="#modal">Modifier
                                </button>
                            </div>
                            <div class="col-md-1">
                                <button type="button" name="{{ matos.id }}" class="btn btn-danger suppr-btn"
                                        href="javascript:supprimer({{ matos.id }});"
                                        data-toggle="confirmation" data-btn-ok-label="Oui"
                                        data-btn-cancel-label="Non" data-btn-cancel-class="btn-danger"
                                        data-title="Supprimer ce matériel ?">Supprimer
                                </button>
                            </div>
                        </div>
                    </div>
                </div>
            {% empty %}
                <p>Il n'y a pas de materiel </p>
            {% endfor %}
            <hr>
        {% endfor %}

    </div>
{% endblock %}

{% block footer_javascript %}
    {# Plugin Date Time Picker #}
    <script type="text/javascript" src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/moment.min.js"></script>
    <script type="text/javascript"
            src="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/js/tempusdominus-bootstrap-4.min.js"></script>
    <link rel="stylesheet"
          href="https://cdnjs.cloudflare.com/ajax/libs/tempusdominus-bootstrap-4/5.0.0/css/tempusdominus-bootstrap-4.min.css"/>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/moment.js/2.22.2/locale/fr.js"></script>

    {# Plugin confirmation box #}
    <script src="https://cdn.jsdelivr.net/npm/bootstrap-confirmation2@4.0.0/dist/bootstrap-confirmation.min.js"></script>


    <script type="text/javascript">
        $(function () {
            $('[data-toggle=confirmation]').confirmation({
                rootSelector: '[data-toggle=confirmation]'
            });

            $('#id_anneeAchat').datetimepicker({
                locale: 'fr',
                format: 'L'
            });

            $('#modal').on('show.bs.modal', function (event) {
                let button = $(event.relatedTarget);
                if (button.attr('id') === "btn-ajoutType") {
                    $.ajax({
                        url: '{% url 'ajout_type_materiel_modal' %}',
                        dataType: 'html',
                        data: {
                            'csrfmiddlewaretoken': '{{ csrf_token }}',
                        },
                        type: 'POST',
                        success: function (data) {
                            $('#modal .modal-content').html(data);
                        }
                    });
                } else if (/^modifier-[0-9]*$/.test(button.attr('id'))) {
                    let id = parseInt(button.attr('id').substring(9));
                    $.ajax({
                        url: '{% url 'modifier_materiel_modal' %}',
                        dataType: 'html',
                        data: {
                            'id': id,
                            'csrfmiddlewaretoken': '{{ csrf_token }}',
                        },
                        type: 'POST',
                        success: function (data) {
                            $('#modal .modal-content').html(data);
                        }
                    });
                }
            });

            $('#modal').on('hide.bs.modal', function (event) {
                $('#modal-content').html('<p>Chargement ...</p>')
            });
        });

        function supprimer(id) {
            $.ajax({
                url: '{% url 'suppr_materiel' %}',
                data: {
                    'id': id,
                    'csrfmiddlewaretoken': '{{ csrf_token }}',
                },
                dataType: 'json',
                type: 'POST',
                success: function (data) {
                    if (data['success']) {
                        $('#row-' + data['id']).hide();
                    } else {
                        alert("Erreur dans la suppression : Contactez les administrateurs du site !");
                    }
                },
                error: function () {
                    alert("Erreur : Merci de recommencer la procédure.");
                    location.reload();
                }
            });
        }

        function toggleForm() {
            $('#addForm').collapse('toggle');
            if ($('#collapseLinkForm').hasClass('toggle-on')) {
                $('#collapseLinkForm').removeClass('toggle-on');
                $('#collapseLinkForm').addClass('toggle-off');
            } else {
                $('#collapseLinkForm').removeClass('toggle-off');
                $('#collapseLinkForm').addClass('toggle-on')
            }
        }
    </script>
{% endblock %}